Option Explicit

Global LastResp As String
Global online As Integer     ' true if in transparent mode
Global loggedin As Integer   ' true if logged in
Global zversion As Single    ' Zephyr version number
Global baudrate As Integer
Global ComPort As Integer

Global Const maxtext% = 19
Global Const maxnumb% = 24

Type Tsetup
    name As String
    num1 As String
    num2 As String
    txm As Integer
    rxm As Integer
    bitr As Integer
    unuse As Integer
    Telco As Integer
End Type

Type Zmode
    spid1 As String
    spid2 As String
    phon1 As String
    phon2 As String
    Telco As Integer   '0=PTP, 1=NI1, 2=ETS300
End Type

Global ZephMode As Zmode

Declare Function GetProfileString Lib "Kernel" (ByVal SName$, ByVal KName$, ByVal Def$, ByVal Ret$, ByVal Size%) As Integer
Declare Function WriteProfileString% Lib "Kernel" (ByVal lpAppName$, ByVal lpKeyName$, ByVal lpString$)

'Handshaking
Global Const MSCOMM_HANDSHAKE_NONE = 0
Global Const MSCOMM_HANDSHAKE_XONXOFF = 1
Global Const MSCOMM_HANDSHAKE_RTS = 2
Global Const MSCOMM_HANDSHAKE_RTSXONXOFF = 3

'Event constants
Global Const MSCOMM_EV_SEND = 1
Global Const MSCOMM_EV_RECEIVE = 2
Global Const MSCOMM_EV_CTS = 3
Global Const MSCOMM_EV_DSR = 4
Global Const MSCOMM_EV_CD = 5
Global Const MSCOMM_EV_RING = 6
Global Const MSCOMM_EV_EOF = 7

'Error code constants
Global Const MSCOMM_ER_BREAK = 1001
Global Const MSCOMM_ER_CTSTO = 1002
Global Const MSCOMM_ER_DSRTO = 1003
Global Const MSCOMM_ER_FRAME = 1004
Global Const MSCOMM_ER_OVERRUN = 1006
Global Const MSCOMM_ER_CDTO = 1007
Global Const MSCOMM_ER_RXOVER = 1008
Global Const MSCOMM_ER_RXPARITY = 1009
Global Const MSCOMM_ER_TXFULL = 1010
Global Const MSCOMM_ER_NOTAVAIL = 68

Sub AddChar (st As String, add As String)
      ' This function is only used to create the Log output text !
      If add <> Chr$(10) Then
        st = st + add
        If add = Chr$(13) Then st = st + Chr$(10)
      End If
End Sub

Sub CenterAtoB (a As Form, b As Form)
  a.Left = b.Left + (b.Width - a.Width) / 2
  a.Top = b.Top + (b.Height - a.Height) / 2
End Sub

Function CheckNumber (co As Control, key As Integer) As Integer
  ' return true if text too long or invalid numbers
  Dim n As Integer

  CheckNumber = True
  Select Case key
    Case Asc("0") To Asc("9"), Asc("#"), Asc("*")
      n = 1
    Case 8
      n = -1
    Case 13
      n = 0
    Case Else
      Beep
      key = 0
      Exit Function  ' error
  End Select
  If Len(co.Text) + n > maxnumb% Then
    Beep
    key = 0
    Exit Function
  End If
  CheckNumber = False
End Function

Function GetStrg (st As String)
  Dim i As Integer
  
  i = InStr(st, Chr$(0))
  If i > 1 Then GetStrg = Left$(st, i - 1) Else GetStrg = ""
End Function

Sub PutLog (lstr As String)
    Dim st As String
    If lstr <> "" Then
        st = FoLog.TxLog.Text
        st = st + lstr
        If Len(st) > 10000 Then st = Right$(st, 8000)
        FoLog.TxLog.Text = st
        FoLog.TxLog.SelStart = Len(FoLog.TxLog.Text)
    End If
End Sub

Sub SelAll (te As TextBox)
  te.SelStart = 0
  te.SelLength = Len(te.Text)
End Sub

Function Send (strg As String, timo As Integer) As String
    ' Send a string to Zephyr, receive the echo back and wait for a
    ' response including the system prompt. Cut off the direct echo
    ' and return response + prompt

    Dim resp As String
    Dim sl As Integer

    FoMain.TiPoll.Enabled = False
    FoMain.ComZeph.Output = strg + Chr$(13)   ' Send string

    'Debug.Print ">"; strg; "<"

    resp = SeriGet(timo)               ' Read Zephyr's response

    'Debug.Print "<"; resp; ">"

    sl = Len(strg)
    If sl > 0 Then
      If Left$(resp, sl) = strg Then resp = Mid$(resp, sl + 1)
    Else
      If Left$(resp, 1) = "@" Then resp = Mid$(resp, 2)
    End If

    'Debug.Print "<"; resp; ">"

    Send = resp
    FoMain.TiPoll.Enabled = True
End Function

Function SeriGet (timo As Integer) As String
    ' Read everything from the serial port up to either the first
    ' ocurrence of the system prompt '>>' or until a timeout occurs.
    ' Discard all CR characters. The prompt will also be returned
    Dim ende As Long
    Dim num, prcnt As Integer
    Dim strg, char As String
    Dim lstr As String

    ende = Timer + timo
    prcnt = 0
    strg = ""
    Do
      While FoMain.ComZeph.InBufferCount
        char = FoMain.ComZeph.Input
        
        AddChar lstr, char

        If char <> Chr$(13) Then
          If char <> Chr$(10) Then strg = strg + char Else strg = strg + "@"
        End If
        
        If char = ">" Then
          prcnt = prcnt + 1
          If prcnt = 2 Then GoTo ende
        Else
          prcnt = 0
        End If
        ende = Timer + timo
      Wend
      DoEvents
    Loop While Timer <= ende
ende:
    'LaCom2.Caption = "(" + char + ")"
    'Debug.Print ":"; SerStr
    'Debug.Print ":"; strg
    PutLog lstr
    SeriGet = strg
End Function

Sub SetOptions (ByVal baud As Integer, ByVal cport As Integer)
    If baud <> -1 Then
        FoMain.MO2400.Checked = False
        If baud = 2400 Then FoMain.MO2400.Checked = True
        FoMain.MO9600.Checked = False
        If baud = 9600 Then FoMain.MO9600.Checked = True
        baudrate = baud
    End If
    If cport <> -1 Then
        ComPort = cport
    End If
End Sub

Sub UpdateISDN ()
    Dim st, va As String

    '---- SPIDs
    st = "spids "
    va = ZephMode.spid1
    If va = "" Then va = "-"
    st = st + va + " "
    va = ZephMode.spid2
    If va = "" Then va = "-"
    st = st + va
    If Wait(st, 3, "ERROR") = 0 Then GoTo fehler
    '---- Directory numbers
    st = "direc "
    va = ZephMode.phon1
    If va = "" Then va = "-"
    st = st + va + " "
    va = ZephMode.phon2
    If va = "" Then va = "-"
    st = st + va
    If Wait(st, 3, "ERROR") = 0 Then GoTo fehler
    '---- Telco
    st = "telco "
    Select Case ZephMode.Telco
        Case 0
            st = st + "PTP"
        Case 1
            st = st + "NI1"
        Case 2
            st = st + "ETS300"
    End Select
    If Wait(st, 3, "ERROR") = 0 Then GoTo fehler
    Exit Sub
fehler:
    MsgBox "ISDN settings update failed.", 16, "Info"
    Exit Sub
End Sub

Function Wait (ByVal cmd As String, ByVal timo As Integer, ByVal comp As String) As Integer
    ' Send a command to Zephyr, wait for response and test
    ' whether the string 'comp' can be found in the response
    ' Return value: 0=found it, 1=got wrong response, 2=timeout, 3=NO RESP
    ' 4=RESP is CR
    Dim strg As String
    Dim sl, res As Integer

    res = 0                          ' default return value
    strg = Send(cmd, timo)           ' Send command and get reply
    If Right$(strg, 2) = ">>" Then   ' test whether timeout occured
      sl = Len(strg)
      If sl <= 3 Then
        If comp = "" Then res = 0 Else res = 1
      Else
        strg = Left$(strg, sl - 3)
        If InStr(strg, comp) = 0 Then res = 1 Else res = 0
        LastResp = strg
        ' Debug.Print "Z: "; LastResp
      End If
    Else                             ' timeout
      Select Case strg
        Case ""
            res = 3
        Case "@"
            res = 4
        Case Else
            res = 2
      End Select
    End If

    'Debug.Print "res="; res

    Wait = res
End Function

